
from time import time

from intcode import IntCode


class Drone:
    def __init__(self, memory):
        self.memory = memory

    def check_position(self, x, y):
        intcode = IntCode(self.memory)
        program = intcode.execute()
        intcode.input_queue.put(x)
        intcode.input_queue.put(y)
        return next(program)

    def trace(self, x, y, length, dx, dy):
        count = 0
        for _ in range(length):
            if self.check_position(x, y) == 0:
                break
            count += 1
            x, y = x+dx, y+dy
        return count


def main():
    memory = [109,424,203,1,21101,11,0,0,1106,0,282,21101,18,0,0,1106,0,259,1202,1,1,221,203,1,21102,31,1,0,1105,1,282,21101,0,38,0,1106,0,259,21002,23,1,2,22102,1,1,3,21102,1,1,1,21102,57,1,0,1106,0,303,2102,1,1,222,21002,221,1,3,20102,1,221,2,21102,1,259,1,21102,1,80,0,1105,1,225,21102,105,1,2,21102,91,1,0,1105,1,303,1202,1,1,223,20102,1,222,4,21102,259,1,3,21101,225,0,2,21101,225,0,1,21102,118,1,0,1106,0,225,20101,0,222,3,21101,157,0,2,21102,133,1,0,1106,0,303,21202,1,-1,1,22001,223,1,1,21102,1,148,0,1105,1,259,2101,0,1,223,20101,0,221,4,20101,0,222,3,21102,21,1,2,1001,132,-2,224,1002,224,2,224,1001,224,3,224,1002,132,-1,132,1,224,132,224,21001,224,1,1,21102,195,1,0,105,1,108,20207,1,223,2,20101,0,23,1,21102,-1,1,3,21101,0,214,0,1106,0,303,22101,1,1,1,204,1,99,0,0,0,0,109,5,1201,-4,0,249,21202,-3,1,1,21202,-2,1,2,22102,1,-1,3,21101,0,250,0,1106,0,225,22101,0,1,-4,109,-5,2106,0,0,109,3,22107,0,-2,-1,21202,-1,2,-1,21201,-1,-1,-1,22202,-1,-2,-2,109,-3,2105,1,0,109,3,21207,-2,0,-1,1206,-1,294,104,0,99,22102,1,-2,-2,109,-3,2106,0,0,109,5,22207,-3,-4,-1,1206,-1,346,22201,-4,-3,-4,21202,-3,-1,-1,22201,-4,-1,2,21202,2,-1,-1,22201,-4,-1,1,21201,-2,0,3,21101,0,343,0,1105,1,303,1105,1,415,22207,-2,-3,-1,1206,-1,387,22201,-3,-2,-3,21202,-2,-1,-1,22201,-3,-1,3,21202,3,-1,-1,22201,-3,-1,2,21201,-4,0,1,21102,384,1,0,1106,0,303,1106,0,415,21202,-4,-1,-4,22201,-4,-3,-4,22202,-3,-2,-2,22202,-2,-4,-4,22202,-3,-2,-3,21202,-4,-1,-2,22201,-3,-2,1,21201,1,0,-4,109,-5,2105,1,0]
    drone = Drone(memory)

    count = 0
    for y in range(50):
        for x in range(50):
            count += drone.check_position(x, y)
    print(f'part1: count: {count}')

    box_size = 100
    base_x = 10
    for base_y in range(20):
        if drone.check_position(base_x, base_y) == 1:
            break

    box_fits = False
    while not box_fits:
        count = drone.trace(base_x, base_y, box_size, 1, 0)
        if count == 0:
            base_x += 1
        elif count < box_size:
            base_y += 1
        else:
            count = drone.trace(base_x, base_y, box_size, 0, 1)
            if count < box_size:
                base_x += 1
            else:
                box_fits = True
    print(f'part2: coord score: {base_x * 10000 + base_y}')


if __name__ == '__main__':
    start = time()
    main()
    print(f'Time: {time()-start:.3}')
